#include "settings.lua"

function init()
  if not HasKey(SETTINGS_BASE) then
    SetDefaults()
  end
  checkSettingsVersion()
  checkKeybinds()
  checkGroup()

  modKeyName = nil

end


function draw(dt)

  -- title
  UiPush()
    UiTranslate(UiCenter(), 100)

    UiPush()
      UiAlign("center middle")
      UiFont("bold.ttf", 64)
      UiText("Infinite Plank")
    UiPop()

    UiTranslate(0, 100)
  UiPop()

  -- group buttons
  UiPush()
    UiTranslate(500, 300)
    UiAlign("center middle")
    UiColor(1, 1, 0.5, 1)
    UiFont("bold.ttf", 42)
    UiText("Tool Group")

    UiTranslate(0, 0)
    UiFont("bold.ttf", 26)
    
    local group = GetInt(SETTINGS_BASE .. ".group")

    for i = 0, 6 do
      UiTranslate(0, 60)

      if i == group then
        UiColor(1, 1, 1, 1)
      else
        UiColor(1, 1, 1, 0.5)
      end

      local text = "GROUP " .. i
      if i == 0 then
        text = "REPLACE VANILLA PLANK"
      end


      UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.2)

      if UiTextButton(text) then
        group = i
        SetInt(SETTINGS_BASE .. ".group", group)
        SetInt(SETTINGS_BASE .. ".popup", false)
      end

    end

  UiPop()

  -- keybinds
  UiPush()
    UiTranslate(UiWidth()-600, 300)
    
    -- title
    UiAlign("center middle")
    UiColor(1,1,0.5)
    UiFont('bold.ttf',42)
    UiText("Keybinds")
    
    -- bind names 
    UiTranslate(0,90)
    local binds = ListKeys(SETTINGS_BASE .. ".binds")
    for i=1,#binds do
      local name = binds[i]

      UiPush()
        -- description
        UiAlign("right middle")
        UiColor(1,1,1)
        UiFont('regular.ttf',32)
        local desc = GetString(SETTINGS_BASE .. ".binds." .. name .. ".desc")
        UiText(desc)
        UiTranslate(40,0)

        -- key
        UiAlign("left middle")
        UiColor(1,1,0)
        UiFont('bold.ttf',32)
        local key = GetString(SETTINGS_BASE .. ".binds." .. name .. ".key")
        local shift = GetBool(SETTINGS_BASE .. ".binds." .. name .. ".shift")
        local alt   = GetBool(SETTINGS_BASE .. ".binds." .. name .. ".alt")
        local ctrl  = GetBool(SETTINGS_BASE .. ".binds." .. name .. ".ctrl")
        
        UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.2)
        if modKeyName == name then
          UiColor(1,0.5,0)
          UiText("Press Key (combo)")
          if InputPressed("any") and not InputPressed("esc") and not InputPressed("lmb") and InputLastPressedKey() ~= "" and not InputPressed("shift") and not InputPressed("ctrl") and not InputPressed("alt") then
            shift = false
            alt = false
            ctrl = false
            if InputDown("shift") then
              shift = true
            end
            if InputDown("alt") then
              alt = true
            end
            if InputDown("ctrl") then
              ctrl = true
            end
            key = InputLastPressedKey()
            setKeybind(desc, name, key, shift, alt, ctrl)
            modKeyName = nil
          end
        else
          local combo = ""
          if ctrl then
            combo = combo .. " CTRL + "
          end
          if alt then
            combo = combo .. " ALT + "
          end
          if shift then
            combo = combo .. " SHIFT + "
          end
          combo = combo .. key
          combo = string.upper(combo)
          if UiTextButton(combo) then
            -- print('pressed: '.. name)
            modKeyName = name
          end
        end
      UiPop()

      UiTranslate(0,80)
    end

  UiPop()


  -- close
  UiPush()
    UiAlign("center middle")
    UiTranslate(UiCenter(), UiHeight() - 80)

    UiColor(1, 1, 1, 0.9)
    UiFont("bold.ttf", 32)

    UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.9)

    if UiTextButton("CLOSE", 200, 60) then
      Menu()
    end
  UiPop()

  -- defaults
  UiPush()
    UiAlign("right middle")
    UiTranslate(UiWidth() - 80, UiHeight() - 80)

    UiColor(1, 1, 1, 0.5)
    UiFont("bold.ttf", 32)

    UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.6)

    if UiTextButton("DEFAULTS", 200, 60) then
      SetDefaults()
    end
  UiPop()
end

