SETTINGS_BASE = "savegame.mod.infiniteplank"


function initKeybind(desc, name, key, shift, alt, ctrl)
  local base = SETTINGS_BASE .. ".binds." .. name
  if not HasKey(base) then
    SetString(base .. ".desc", desc)
    SetString(base .. ".key", key)
    SetBool(base .. ".shift", shift)
    SetBool(base .. ".alt", alt)
    SetBool(base .. ".ctrl", ctrl)
    print('key initiated: ', name)
  end
end

function setKeybind(desc, name, key, shift, alt, ctrl)
  local base = SETTINGS_BASE .. ".binds." .. name
  SetString(base .. ".desc", desc)
  SetString(base .. ".key", key)
  SetBool(base .. ".shift", shift)
  SetBool(base .. ".alt", alt)
  SetBool(base .. ".ctrl", ctrl)
  print('key set: ', name)
end

function checkSettingsVersion()
  if HasKey("savegame.mod.infiniteplank_shift") then
    -- make sure previous settings remain
    local key = GetString(SETTINGS_BASE)
    local shift = GetBool(SETTINGS_BASE .. "_shift")
    local alt   = GetBool(SETTINGS_BASE .. "_alt")
    local ctrl  = GetBool(SETTINGS_BASE .. "_ctrl")
    local group = GetInt( SETTINGS_BASE .. "_group")
    local popup = GetBool(SETTINGS_BASE .. "_popup")
    local style = GetInt( SETTINGS_BASE .. "_style")
    local width = GetInt( SETTINGS_BASE .. "_width")

    -- clear all and old settings
    ClearKey(SETTINGS_BASE)
    ClearKey(SETTINGS_BASE .. "_shift")
    ClearKey(SETTINGS_BASE .. "_alt")
    ClearKey(SETTINGS_BASE .. "_ctrl")
    ClearKey(SETTINGS_BASE .. "_group")
    ClearKey(SETTINGS_BASE .. "_popup")
    ClearKey(SETTINGS_BASE .. "_style")
    ClearKey(SETTINGS_BASE .. "_width")

    -- set new ones
    initKeybind("Plank switch", "switch", key, shift, alt, ctrl)
    SetInt(SETTINGS_BASE .. ".group", group)
    SetBool(SETTINGS_BASE .. ".popup", not popup)
    SetInt(SETTINGS_BASE .. ".style", style)
    SetInt(SETTINGS_BASE .. ".width", width)
    SetInt(SETTINGS_BASE .. ".height", 1)

  end
end

function checkKeybinds()
  initKeybind("Switch",   "switch",     "g",          false, false, false)
  initKeybind("+ Width",  "width_add",  "rightarrow", false, false, false)
  initKeybind("- Width",  "width_sub",  "leftarrow",  false, false, false)
  initKeybind("+ Height", "height_add", "uparrow",    false, false, false)
  initKeybind("- Height", "height_sub", "downarrow",  false, false, false)
end

function SetDefaults()
  -- clear all and old settings
  ClearKey(SETTINGS_BASE)
  ClearKey(SETTINGS_BASE .. "_shift")
  ClearKey(SETTINGS_BASE .. "_alt")
  ClearKey(SETTINGS_BASE .. "_ctrl")
  ClearKey(SETTINGS_BASE .. "_group")
  ClearKey(SETTINGS_BASE .. "_popup")
  ClearKey(SETTINGS_BASE .. "_style")
  ClearKey(SETTINGS_BASE .. "_width")
  -- set all the things..
  setKeybind("Switch",   "switch",     "g",          false, false, false)
  setKeybind("+ Width",  "width_add",  "rightarrow", false, false, false)
  setKeybind("- Width",  "width_sub",  "leftarrow",  false, false, false)
  setKeybind("+ Height", "height_add", "uparrow",    false, false, false)
  setKeybind("- Height", "height_sub", "downarrow",  false, false, false)
  SetInt(SETTINGS_BASE .. ".group", 6)
  SetBool(SETTINGS_BASE .. ".popup", true)
  SetInt(SETTINGS_BASE .. ".style", 1)
  SetInt(SETTINGS_BASE .. ".width", 5)
  SetInt(SETTINGS_BASE .. ".height", 1)
end


function checkGroup()
  if not HasKey(SETTINGS_BASE .. ".group") then
    SetInt(SETTINGS_BASE .. ".group", 6)
    print('group initiated')
  end
end
